\documentclass{article}
\usepackage{amsmath}
\usepackage{graphicx}
\begin{document}
	(a) Let $OPT$ denotes the optimal output of BalancedSum. Knowing that the output is the larger sum of two subsets, 
	\begin{equation}
	OPT \geq \frac{1}{2} \sum_{i=1}^{n}X[i]
	\end{equation}
	
	Let $max$ and $min$ denote the larger summation and smaller summation of two subsets produced by GreedyPartition. From the algorithm, we know that
	\begin{equation}
	max + min = \sum_{i=1}^{n}X[i]
	\end{equation}
	\begin{equation}
	0 \leq max - min \leq \max_{i}X[i] 
	\end{equation}
	
	Proof for equation (3): Without loss of generality, assume $a$ is the larger subset sum. Let $X[j]$ be the last element in $a$, i.e., all $X[j+1], X[j+2], ... , X[n]$ are in $b$, the smaller subset sum. Consider when $X[j]$ is assigned to $a$. Let us call the two sets $a'$ and $b'$ correspondingly. After the assignment, $a' - b' \leq X[j]$. Knowing that all $X[j+1], X[j+2], \dots , X[n]$ are in $b$, 
	$$a - b \leq X[j]-(X[j+1] + X[j+2] + \dots +  X[n]) \leq \max_{i}X[i]$$
	
	According to (2) and (3), 
	\begin{equation}
	max \leq \frac{1}{2} \sum_{i=1}^{n}X[i]+ \frac{1}{2} \max_{i}X[i]
	\end{equation}

	Now consider 2 scenarios. (i) $\max_{i}X[i] \geq \frac{1}{2} \sum_{i=1}^{n}X[i]$: $OPT$ only contains $\max_{i}X[i]$. Then 
	$$OPT = \max_{i}X[i] \geq \frac{1}{2} \sum_{i=1}^{n}X[i]$$. 
	According to (4), 
	$$max \leq \frac{1}{2} \sum_{i=1}^{n}X[i]+ \frac{1}{2} \max_{i}X[i] \leq OPT + \frac{1}{2}OPT = \frac{3}{2} OPT $$.
	
	(ii) $\max_{i}X[i] < \frac{1}{2} \sum_{i=1}^{n}X[i]$: then According to (1),
	$$ \max_{i}X[i] < \frac{1}{2} \sum_{i=1}^{n}X[i] \leq OPT$$
	According to (4), $$max \leq \frac{1}{2} \sum_{i=1}^{n}X[i]+ \frac{1}{2} \max_{i}X[i] \leq OPT + \frac{1}{2}OPT = \frac{3}{2} OPT $$.
	
	From (i) and (ii),, the algorithm is a $\frac{3}{2}$-approximation algorithm.
	
	~\
	
	(b) $X=\{3, 3, 6\}$, in that case, $OPT = 6$, the output generated by greedy algorithm is 9. 
	
	~\
	
	(c) Let $OPT$ denotes the optimal output of BalancedSum. Knowing that the output is the larger sum of two subsets, 
	\begin{equation}
		OPT \geq \frac{1}{2} \sum_{i=1}^{n}X[i]
	\end{equation}
	
	Let $max$ and $min$ denote the larger summation and smaller summation of two subsets produced by GreedyPartition.
	
	Now consider 2 scenarios. (i) $\max_{i}X[i] \geq \frac{1}{2} \sum_{i=1}^{n}X[i]$: $OPT$ only contains $\max_{i}X[i]$. Then 
	$$OPT = \max_{i}X[i]$$. For the greedy algorithm,  $\max_{i}X[i]$ will be assigned to $a$ and all other elements will assign to $b$, the output is $a = \max_{i}X[i]$. So,
	$$max = OPT$$
	
	(ii) $\max_{i}X[i] < \frac{1}{2} \sum_{i=1}^{n}X[i]$: Without loss of generality, assume $a$ is the larger subset sum. Let $X[j]$ be the last element in $a$, i.e., all $X[j+1], X[j+2], ... , X[n]$ are in $b$, the smaller subset sum. Consider when $X[j]$ is assigned to $a$. Let us call the two sets $a'$ and $b'$ correspondingly. After the assignment, $a' - b' \leq X[j]$. Knowing that 
	$$ X[1] \geq X[2] \geq \dots \geq X[j-1] \geq X[j]$$
	
	and there must be at least 1 element $\in \{X[1], X[2], \dots, X[j-1]\}$ in $b'$, so $b' \geq X[j]$.
	So 
	\begin{align*}
		&a = a' \quad \text {(X[j] is the last element in a)} \\		
		&b \geq b' \\
		&a' - b' \leq X[j] \\
		&X[j] \leq b'
	\end{align*}
	We get 
	\begin{equation}
		a - b \leq b
	\end{equation}
	So
	\begin{equation}
		max \leq 2 \cdot min
	\end{equation}
	Knowing that $max + min = \sum_{i=1}^{n}X[i]$, we get
	\begin{equation}
		max \leq \frac{2}{3} \cdot \sum_{i=1}^{n}X[i]
	\end{equation}
	According to (5) and (8),
	$$ max \leq \frac{2}{3} \cdot \sum_{i=1}^{n}X[i] \leq \frac{4}{3} \cdot \frac{1}{2} \sum_{i=1}^{n}X[i] \leq \frac{4}{3} OPT$$ 
	
	From (i) and (ii), the algorithm is a $\frac{4}{3}$-approximation algorithm for sorted array in descent order.
\end{document}